#Name: xxlfastxymaster
#Info: Find and replace plugin for xxl 2 machine setup with motorized table! Set table width to 395!
#Depend: GCode
#Type: postprocess
#Param: fromLayer(float:0) Start effect from (layer nr)

# SPECIAL THANKS TO: Jelle, Hendrik and jeremie [http://betterprinter.blogspot.fr/2013/02/how-tun-run-python-cura-plugin-without.html]

# see my projects on:
# www.rooiejoris.nl
# www.facebook.com/europerminutedesign
# www.thingiverse.com/joris

# www.kamermaker2013.tudelft.nl


import re, math

############ BEGIN CURA PLUGIN STAND-ALONIFICATION ############
# This part is an "adapter" to Daid's version of my original Cura/Skeinforge plugin that
# he upgraded to the lastest & simpler Cura plugin system. It enables commmand-line
# postprocessing of a gcode file, so as to insert the temperature commands at each layer.
#
# Also it is still viewed by Cura as a regular and valid plugin!
#
# To run it you need Python, then simply run it like
#   wood_standalone.py --min minTemp --max maxTemp --grain grainSize --file gcodeFile
# It will "patch" your gcode file with the appropriate M104 temperature change.
#
import inspect
import sys
import getopt

def plugin_standalone_usage(myName):
 print "Usage:"
 print "  "+myName+" fromlayer -f gcodeFile"
 print "Standalone usage Licensed under CC-BY-NC from Jeremie.Francois@gmail.com (betterprinter.blogspot.com)"
 print "find replace fast xxl script Licensed under CC-BY-NC from www.rooiejoris.nl"
 sys.exit()

try:
 filename
except NameError:
 # Then we are called from the command line (not from cura)
 # trying len(inspect.stack()) > 2 would be less secure btw
 opts, extraparams = getopt.getopt(sys.argv[1:],'n:f',['fromlayer=','file=']) 

 fromLayer = 0;
 filename="test.g"

 for o,p in opts:
  if o in ['-n','--fromlayer']:
   layerheight = float(p)
  elif o in ['-f','--file']:
   filename = p
 #  filename = 'test.g'
 if not filename:
  plugin_standalone_usage(inspect.stack()[0][1])
#  plugin_standalone_usage('test.g')
#
############ END CURA PLUGIN STAND-ALONIFICATION ############



def getValue(line, key, default = None):
       if not key in line or (';' in line and line.find(key) > line.find(';')):
               return default
       subPart = line[line.find(key) + 1:]
       m = re.search('^[0-9]+\.?[0-9]*', subPart)
       if m == None:
               return default
       try:
               return float(m.group(0))
       except:
               return default

               
               
with open(filename, "r") as f:
       lines = f.readlines()

z = 0
x = 0
y = 0
e = 0
v = 0
startEffect = 0
layer = 0
#persistentZ = 0



with open(filename, "w") as f:
#       print("binnen")

       for line in lines:
#               print("binnen")
               if ";LAYER:" in line:
#                    print("binnen")
                    startEffect = 1
                    layer = line[7:]
#                    print(layer)

               
               e = getValue(line, "E", e)        

# search for T1 line
               if (getValue(line, "T", None) == 1) and startEffect == 1:
#               if (getValue(line, "T", None) == 1):
                    f.write(";==================================================================================\n")
                    f.write(";joris\n")
                    f.write(";start T1 move table left\n")
                    f.write("G4 P1 ;wait 100ms\n")
                    f.write("G1 F3000 ;set feedrate\n")
                    f.write("M601 X0 Y180 Z0 E0 L0	;wacht op slave klaar\n")
                    f.write("G1 X20 Y40\n")
                    f.write(";tafel bewegen\n")
                    f.write("T1\n")
                    f.write("G90\n")					
                    f.write("G92 E0\n")
                    f.write("M83\n")
                    f.write("G1	F5 E-0.005\n")
                    f.write("G1	F10 E-0.005\n")
                    f.write("G1 F20 E-0.010\n")
                    f.write("G1 F30 E-0.010\n")
                    f.write("G1	F40 E-0.01\n")
                    f.write("G1	F50 E-0.02\n")
                    f.write("G1 F60 E-0.02\n")
                    f.write("G1 F70 E-0.02\n")
                    f.write("G1	F80 E-0.03	\n")
                    f.write("G1	F90 E-0.03\n")
                    f.write("G1	F100 E-0.03\n")
                    f.write("G1 F120 E-0.04\n")
                    f.write("G1 F130 E-0.04\n")
                    f.write("G1	F140 E-0.05\n")
                    f.write("G1	F150 E-0.05\n")
                    f.write("G1 F160 E-0.05\n")
                    f.write("G1 F170 E-0.06\n")
                    f.write("G1	F180 E-0.06\n")
                    f.write("G1	F190 E-0.06\n")
                    f.write("G1	F200 E-0.07\n")
                    f.write("G1 F220 E-0.07\n")
                    f.write("G1 F230 E-0.07\n")
                    f.write("G1	F240 E-0.08\n")
                    f.write("G1	F250 E-0.08\n")
                    f.write("G1 F260 E-0.09	\n")
                    f.write("G1 F270 E-0.09\n")
                    f.write("G1	F280 E-0.1\n")
                    f.write("G1	F290 E-0.1\n")
                    f.write("G1	F300 E-0.1\n")
                    f.write("G1	F300 E-0.1\n")
                    f.write("G1 F300 E-7.40\n")
                    f.write("G1	F300 E-0.3\n")
                    f.write("G1	F200 E-0.2\n")
                    f.write("G1 F100 E-0.1\n")
                    f.write("G92 E+9.29\n")
                    f.write("G4 P1 ;wait 100ms\n")
                    f.write("G92 X+210 Y+40\n")
                    f.write("M82\n")
                    f.write("T0\n")
                    f.write("G90\n")
                    f.write(";tafel klaar\n")
                    f.write("G4 P1\n")
                    f.write("M42 P9	S255 ;zeg tegen slave, ga lekker printen\n")
                    f.write("M42 P11 S255\n")
                    f.write("G4 P500\n")
                    f.write("M42 P9	S0 ;trek command terug\n")
                    f.write("M42 P11 S0\n")
                    f.write("G92 E%0.4f " %(e+2))
                    f.write("\n")
                    f.write(";==================================================================================\n")

# search for T1 line
               elif (getValue(line, "T", None) == 0) and startEffect == 1:

#                if (getValue(line, "T", None) == 0):
                    f.write(";==================================================================================\n")
                    f.write(";joris\n")
                    f.write(";start T0 move table left\n")
                    f.write("G4 P1 ;wait 100ms\n")
                    f.write("G1 F3000 ;set feedrate\n")
                    f.write("M601 X0 Y180 Z0 E0 L0	;wacht op slave klaar\n")
                    f.write("G1 X240 Y40\n")
                    f.write(";tafel bewegen\n")
                    f.write("T1\n")
                    f.write("G90\n")					
                    f.write("G92 E0\n")
                    f.write("M83\n")
# ook een keer testen met acceleratie
# M204 - Set default acceleration: S normal moves T filament only moves (M204 S3000 T7000) im mm/sec^2 also sets minimum segment time in ms (B20000) to prevent buffer underruns and M20 minimum feedrate
#                    f.write("M204 T20; 20 is extreem laag\n")
#                    f.write("G1	F400 E-7.55\n")
# later accelaratie ook weer terug zetten
#                    f.write("M204 T300\n")
                    f.write("G1	F5 E0.005\n")
                    f.write("G1	F10 E0.005\n")
                    f.write("G1 F20 E0.010\n")
                    f.write("G1 F30 E0.010\n")
                    f.write("G1	F40 E0.01\n")
                    f.write("G1	F50 E0.02\n")
                    f.write("G1 F60 E0.02\n")
                    f.write("G1 F70 E0.02\n")
                    f.write("G1	F80 E0.03\n")
                    f.write("G1	F90 E0.03\n")
                    f.write("G1	F100 E0.03\n")
                    f.write("G1 F120 E0.04\n")
                    f.write("G1 F130 E0.04\n")
                    f.write("G1	F140 E0.05\n")
                    f.write("G1	F150 E0.05\n")
                    f.write("G1 F160 E0.05\n")
                    f.write("G1 F170 E0.06\n")
                    f.write("G1	F180 E0.06\n")
                    f.write("G1	F190 E0.06\n")
                    f.write("G1	F200 E0.07\n")
                    f.write("G1 F220 E0.07\n")
                    f.write("G1 F230 E0.07\n")
                    f.write("G1	F240 E0.08\n")
                    f.write("G1	F250 E0.08\n")
                    f.write("G1 F260 E0.09\n")
                    f.write("G1 F270 E0.09\n")
                    f.write("G1	F280 E0.1\n")
                    f.write("G1	F290 E0.1\n")
                    f.write("G1	F300 E0.1\n")
                    f.write("G1	F300 E0.1\n")
                    f.write("G1 F300 E7.40\n")
                    f.write("G1	F300 E0.3\n")
                    f.write("G1	F200 E0.2\n")
                    f.write("G1 F100 E0.1\n")
                    f.write("G92 E-9.29\n")
                    f.write("G4 P100\n")
                    f.write("G92 X+50 Y+40\n")
                    f.write("M82\n")
                    f.write("T0\n")
                    f.write("G90\n")
                    f.write(";tafel klaar\n")
                    f.write("G4 P1\n")
                    f.write("M42 P9	S255 ;zeg tegen slave, ga lekker printen\n")
                    f.write("M42 P11 S255\n")
                    f.write("G4 P500\n")
                    f.write("M42 P9	S0 ;trek command terug\n")
                    f.write("M42 P11 S0\n")
                    f.write("G92 E%0.4f " %(e+2))
                    f.write("\n")
                    f.write(";==================================================================================\n")

               else: f.write(line)
